diff --git a/arch/blackfin/config.mk b/arch/blackfin/config.mk
index 4102c6f..95cf7db 100644
--- a/arch/blackfin/config.mk
+++ b/arch/blackfin/config.mk
@@ -25,6 +25,13 @@ CROSS_COMPILE ?= bfin-uclinux-
 
 STANDALONE_LOAD_ADDR = 0x1000 -m elf32bfin
 
+ifeq ($(CONFIG_BFIN_CPU),)
+CONFIG_BFIN_CPU := \
+	$(shell awk '$$2 == "CONFIG_BFIN_CPU" { print $$3 }' \
+		$(src)include/configs/$(BOARD).h)
+else
+CONFIG_BFIN_CPU := $(strip $(subst ",,$(CONFIG_BFIN_CPU)))
+endif
 CONFIG_BFIN_BOOT_MODE := $(strip $(subst ",,$(CONFIG_BFIN_BOOT_MODE)))
 
 PLATFORM_RELFLAGS += -ffixed-P3 -fomit-frame-pointer -mno-fdpic
@@ -34,7 +41,6 @@ LDFLAGS_FINAL += --gc-sections
 LDFLAGS += -m elf32bfin
 PLATFORM_RELFLAGS += -ffunction-sections -fdata-sections
 
-PLATFORM_CPPFLAGS += -DBFIN_CPU='"$(CONFIG_BFIN_CPU)"'
 PLATFORM_RELFLAGS += -mcpu=$(CONFIG_BFIN_CPU)
 
 ifneq ($(CONFIG_BFIN_BOOT_MODE),BFIN_BOOT_BYPASS)
diff --git a/arch/blackfin/include/asm/config.h b/arch/blackfin/include/asm/config.h
index 0437252..f0f3a39 100644
--- a/arch/blackfin/include/asm/config.h
+++ b/arch/blackfin/include/asm/config.h
@@ -12,6 +12,11 @@
 /* Some of our defines use this (like CONFIG_SYS_GBL_DATA_ADDR) */
 #include <asm-offsets.h>
 
+/* Sanity check CONFIG_BFIN_CPU */
+#ifndef CONFIG_BFIN_CPU
+# error CONFIG_BFIN_CPU: your board config needs to define this
+#endif
+
 #ifndef CONFIG_BFIN_SCRATCH_REG
 # define CONFIG_BFIN_SCRATCH_REG retn
 #endif
diff --git a/arch/blackfin/lib/board.c b/arch/blackfin/lib/board.c
index 59a0810..2b1f78c 100644
--- a/arch/blackfin/lib/board.c
+++ b/arch/blackfin/lib/board.c
@@ -254,7 +254,7 @@ void board_init_f(ulong bootflag)
 	memset((void *)bd, 0, sizeof(bd_t));
 
 	bd->bi_r_version = version_string;
-	bd->bi_cpu = BFIN_CPU;
+	bd->bi_cpu = MK_STR(CONFIG_BFIN_CPU);
 	bd->bi_board_name = BFIN_BOARD_NAME;
 	bd->bi_vco = get_vco();
 	bd->bi_cclk = get_cclk();
diff --git a/board/bct-brettl2/config.mk b/board/bct-brettl2/config.mk
index 6e7e543..799a682 100644
--- a/board/bct-brettl2/config.mk
+++ b/board/bct-brettl2/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf536-0.3
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/bf518f-ezbrd/config.mk b/board/bf518f-ezbrd/config.mk
index d941092..799a682 100644
--- a/board/bf518f-ezbrd/config.mk
+++ b/board/bf518f-ezbrd/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf518-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/bf526-ezbrd/config.mk b/board/bf526-ezbrd/config.mk
index 83fd42e..799a682 100644
--- a/board/bf526-ezbrd/config.mk
+++ b/board/bf526-ezbrd/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf526-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/bf527-ad7160-eval/config.mk b/board/bf527-ad7160-eval/config.mk
index 05c7d3b..799a682 100644
--- a/board/bf527-ad7160-eval/config.mk
+++ b/board/bf527-ad7160-eval/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf527-0.2
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/bf527-ezkit/config.mk b/board/bf527-ezkit/config.mk
index b10c3d2..799a682 100644
--- a/board/bf527-ezkit/config.mk
+++ b/board/bf527-ezkit/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf527-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/bf527-sdp/config.mk b/board/bf527-sdp/config.mk
index 47c2989..ce8f75c 100644
--- a/board/bf527-sdp/config.mk
+++ b/board/bf527-sdp/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf527-0.2
-
 CFLAGS_lib_generic += -O2
 CFLAGS_lzma += -O2
 
diff --git a/board/bf533-ezkit/config.mk b/board/bf533-ezkit/config.mk
index c45a197..c0cb9ff 100644
--- a/board/bf533-ezkit/config.mk
+++ b/board/bf533-ezkit/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf533-0.3
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/bf533-stamp/config.mk b/board/bf533-stamp/config.mk
index c45a197..c0cb9ff 100644
--- a/board/bf533-stamp/config.mk
+++ b/board/bf533-stamp/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf533-0.3
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/bf537-minotaur/config.mk b/board/bf537-minotaur/config.mk
index f7aa8ef..4bb6506 100644
--- a/board/bf537-minotaur/config.mk
+++ b/board/bf537-minotaur/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
-
 # Set some default LDR flags based on boot mode.
 LDR_FLAGS-BFIN_BOOT_UART := --port g --gpio 6
diff --git a/board/bf537-pnav/config.mk b/board/bf537-pnav/config.mk
index b48bb00..25f4c15 100644
--- a/board/bf537-pnav/config.mk
+++ b/board/bf537-pnav/config.mk
@@ -23,4 +23,3 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
diff --git a/board/bf537-srv1/config.mk b/board/bf537-srv1/config.mk
index f7aa8ef..4bb6506 100644
--- a/board/bf537-srv1/config.mk
+++ b/board/bf537-srv1/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
-
 # Set some default LDR flags based on boot mode.
 LDR_FLAGS-BFIN_BOOT_UART := --port g --gpio 6
diff --git a/board/bf537-stamp/config.mk b/board/bf537-stamp/config.mk
index 2bb6b79..7c023d1 100644
--- a/board/bf537-stamp/config.mk
+++ b/board/bf537-stamp/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/bf538f-ezkit/config.mk b/board/bf538f-ezkit/config.mk
index 9bae4d1..c0cb9ff 100644
--- a/board/bf538f-ezkit/config.mk
+++ b/board/bf538f-ezkit/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf538-0.4
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/bf548-ezkit/config.mk b/board/bf548-ezkit/config.mk
index 97b64b9..7f38b14 100644
--- a/board/bf548-ezkit/config.mk
+++ b/board/bf548-ezkit/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf548-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/bf561-acvilon/config.mk b/board/bf561-acvilon/config.mk
index 5633b3b..4c811ba 100644
--- a/board/bf561-acvilon/config.mk
+++ b/board/bf561-acvilon/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf561-0.5
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/bf561-ezkit/config.mk b/board/bf561-ezkit/config.mk
index 8b22d0d..4c811ba 100644
--- a/board/bf561-ezkit/config.mk
+++ b/board/bf561-ezkit/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf561-0.3
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/blackstamp/config.mk b/board/blackstamp/config.mk
index 5bf4189..25f4c15 100644
--- a/board/blackstamp/config.mk
+++ b/board/blackstamp/config.mk
@@ -23,4 +23,3 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf532-0.5
diff --git a/board/blackvme/config.mk b/board/blackvme/config.mk
index 620104a..dfcba5c 100644
--- a/board/blackvme/config.mk
+++ b/board/blackvme/config.mk
@@ -22,5 +22,3 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 # MA 02111-1307 USA
 #
-
-CONFIG_BFIN_CPU = bf561-0.5
diff --git a/board/cm-bf527/config.mk b/board/cm-bf527/config.mk
index b10c3d2..799a682 100644
--- a/board/cm-bf527/config.mk
+++ b/board/cm-bf527/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf527-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/cm-bf533/config.mk b/board/cm-bf533/config.mk
index c45a197..c0cb9ff 100644
--- a/board/cm-bf533/config.mk
+++ b/board/cm-bf533/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf533-0.3
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/cm-bf537e/config.mk b/board/cm-bf537e/config.mk
index d5d6dd9..c0cb9ff 100644
--- a/board/cm-bf537e/config.mk
+++ b/board/cm-bf537e/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/cm-bf537u/config.mk b/board/cm-bf537u/config.mk
index d5d6dd9..c0cb9ff 100644
--- a/board/cm-bf537u/config.mk
+++ b/board/cm-bf537u/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/cm-bf548/config.mk b/board/cm-bf548/config.mk
index a28a426..5adb6fc 100644
--- a/board/cm-bf548/config.mk
+++ b/board/cm-bf548/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf548-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/cm-bf561/config.mk b/board/cm-bf561/config.mk
index 8b22d0d..4c811ba 100644
--- a/board/cm-bf561/config.mk
+++ b/board/cm-bf561/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf561-0.3
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/ibf-dsp561/config.mk b/board/ibf-dsp561/config.mk
index 7d25d0b..afa7141 100644
--- a/board/ibf-dsp561/config.mk
+++ b/board/ibf-dsp561/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf561-0.5
-
 # Set some default LDR flags based on boot mode.
 LDR_FLAGS-BFIN_BOOT_PARA := --bits 16
diff --git a/board/ip04/config.mk b/board/ip04/config.mk
index 2e9ee28..7c023d1 100644
--- a/board/ip04/config.mk
+++ b/board/ip04/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf532-0.5
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/board/tcm-bf518/config.mk b/board/tcm-bf518/config.mk
index d941092..799a682 100644
--- a/board/tcm-bf518/config.mk
+++ b/board/tcm-bf518/config.mk
@@ -23,7 +23,5 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf518-0.0
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
diff --git a/board/tcm-bf537/config.mk b/board/tcm-bf537/config.mk
index d5d6dd9..c0cb9ff 100644
--- a/board/tcm-bf537/config.mk
+++ b/board/tcm-bf537/config.mk
@@ -23,8 +23,6 @@
 # MA 02111-1307 USA
 #
 
-CONFIG_BFIN_CPU = bf537-0.2
-
 CFLAGS_lib += -O2
 CFLAGS_lib/lzma += -O2
 
diff --git a/include/configs/bct-brettl2.h b/include/configs/bct-brettl2.h
index fa72c7f..a55e178 100644
--- a/include/configs/bct-brettl2.h
+++ b/include/configs/bct-brettl2.h
@@ -11,7 +11,8 @@
 /*
  * Processor Settings
  */
-#define CONFIG_BFIN_BOOT_MODE	    BFIN_BOOT_BYPASS
+#define CONFIG_BFIN_CPU             bf536-0.3
+#define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
 /*
diff --git a/include/configs/bf518f-ezbrd.h b/include/configs/bf518f-ezbrd.h
index 64ca9ed..6eec1c9 100644
--- a/include/configs/bf518f-ezbrd.h
+++ b/include/configs/bf518f-ezbrd.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf518-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/bf526-ezbrd.h b/include/configs/bf526-ezbrd.h
index 4c30c25..c28f867 100644
--- a/include/configs/bf526-ezbrd.h
+++ b/include/configs/bf526-ezbrd.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf526-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/bf527-ad7160-eval.h b/include/configs/bf527-ad7160-eval.h
index 14ade1b..889bfde 100644
--- a/include/configs/bf527-ad7160-eval.h
+++ b/include/configs/bf527-ad7160-eval.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf527-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_SPI_MASTER
 
 
diff --git a/include/configs/bf527-ezkit.h b/include/configs/bf527-ezkit.h
index fa9053b..22a5639 100644
--- a/include/configs/bf527-ezkit.h
+++ b/include/configs/bf527-ezkit.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf527-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/bf527-sdp.h b/include/configs/bf527-sdp.h
index 3582846..c0e8b5a 100644
--- a/include/configs/bf527-sdp.h
+++ b/include/configs/bf527-sdp.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf527-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/bf533-ezkit.h b/include/configs/bf533-ezkit.h
index e1bb594..95d3afa 100644
--- a/include/configs/bf533-ezkit.h
+++ b/include/configs/bf533-ezkit.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf533-0.3
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/bf533-stamp.h b/include/configs/bf533-stamp.h
index bf0f063..cb37ee7 100644
--- a/include/configs/bf533-stamp.h
+++ b/include/configs/bf533-stamp.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf533-0.3
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/bf537-minotaur.h b/include/configs/bf537-minotaur.h
index 0ba29bc..86aa1f6 100644
--- a/include/configs/bf537-minotaur.h
+++ b/include/configs/bf537-minotaur.h
@@ -24,6 +24,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_SPI_MASTER
 
 
diff --git a/include/configs/bf537-pnav.h b/include/configs/bf537-pnav.h
index da4f2f2..0913ce4 100644
--- a/include/configs/bf537-pnav.h
+++ b/include/configs/bf537-pnav.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_SPI_MASTER
 
 
diff --git a/include/configs/bf537-srv1.h b/include/configs/bf537-srv1.h
index 559428f..7e9dd36 100644
--- a/include/configs/bf537-srv1.h
+++ b/include/configs/bf537-srv1.h
@@ -24,6 +24,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_SPI_MASTER
 
 
diff --git a/include/configs/bf537-stamp.h b/include/configs/bf537-stamp.h
index 2d1930c..3da2375 100644
--- a/include/configs/bf537-stamp.h
+++ b/include/configs/bf537-stamp.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/bf538f-ezkit.h b/include/configs/bf538f-ezkit.h
index 2469c6a..717a35a 100644
--- a/include/configs/bf538f-ezkit.h
+++ b/include/configs/bf538f-ezkit.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf538-0.4
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/bf548-ezkit.h b/include/configs/bf548-ezkit.h
index 1c035cf..e862a8a 100644
--- a/include/configs/bf548-ezkit.h
+++ b/include/configs/bf548-ezkit.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf548-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/bf561-acvilon.h b/include/configs/bf561-acvilon.h
index 2b12c3f..1490b2f 100644
--- a/include/configs/bf561-acvilon.h
+++ b/include/configs/bf561-acvilon.h
@@ -12,7 +12,8 @@
 /*
  * Processor Settings
  */
-#define CONFIG_BFIN_BOOT_MODE		BFIN_BOOT_BYPASS
+#define CONFIG_BFIN_CPU             bf561-0.5
+#define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
 /*
diff --git a/include/configs/bf561-ezkit.h b/include/configs/bf561-ezkit.h
index 7b020e6..7081d5f 100644
--- a/include/configs/bf561-ezkit.h
+++ b/include/configs/bf561-ezkit.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf561-0.3
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/blackstamp.h b/include/configs/blackstamp.h
index 3f5c959..85f08ea 100644
--- a/include/configs/blackstamp.h
+++ b/include/configs/blackstamp.h
@@ -24,6 +24,7 @@
 /* CPU Options
  * Be sure to set the Silicon Revision Correctly
  */
+#define CONFIG_BFIN_CPU		bf532-0.5
 #define CONFIG_BFIN_BOOT_MODE	BFIN_BOOT_SPI_MASTER
 
 /*
diff --git a/include/configs/blackvme.h b/include/configs/blackvme.h
index e4688a2..9950e44 100644
--- a/include/configs/blackvme.h
+++ b/include/configs/blackvme.h
@@ -23,7 +23,8 @@
 #define CONFIG_PANIC_HANG 0
 
 /* CPU Options */
-#define CONFIG_BFIN_BOOT_MODE	BFIN_BOOT_SPI_MASTER
+#define CONFIG_BFIN_CPU        bf561-0.5
+#define CONFIG_BFIN_BOOT_MODE  BFIN_BOOT_SPI_MASTER
 
 /*
  *		CLOCK SETTINGS CAVEAT
diff --git a/include/configs/cm-bf527.h b/include/configs/cm-bf527.h
index 84c9309..e0c6d53 100644
--- a/include/configs/cm-bf527.h
+++ b/include/configs/cm-bf527.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf527-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/cm-bf533.h b/include/configs/cm-bf533.h
index dbc4a5b..7515296 100644
--- a/include/configs/cm-bf533.h
+++ b/include/configs/cm-bf533.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf533-0.3
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/cm-bf537e.h b/include/configs/cm-bf537e.h
index c3de96a..934b74b 100644
--- a/include/configs/cm-bf537e.h
+++ b/include/configs/cm-bf537e.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/cm-bf537u.h b/include/configs/cm-bf537u.h
index e60ebf2..c274c20 100644
--- a/include/configs/cm-bf537u.h
+++ b/include/configs/cm-bf537u.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/cm-bf548.h b/include/configs/cm-bf548.h
index 27b1cc5..fa62a8e 100644
--- a/include/configs/cm-bf548.h
+++ b/include/configs/cm-bf548.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf548-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/cm-bf561.h b/include/configs/cm-bf561.h
index 8c350bc..c60401c 100644
--- a/include/configs/cm-bf561.h
+++ b/include/configs/cm-bf561.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf561-0.3
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/ibf-dsp561.h b/include/configs/ibf-dsp561.h
index e2dbbb1..f3d6c8b 100644
--- a/include/configs/ibf-dsp561.h
+++ b/include/configs/ibf-dsp561.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf561-0.5
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 
diff --git a/include/configs/ip04.h b/include/configs/ip04.h
index 528363c..c024d78 100644
--- a/include/configs/ip04.h
+++ b/include/configs/ip04.h
@@ -20,6 +20,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf532-0.5
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_NAND
 
 
diff --git a/include/configs/tcm-bf518.h b/include/configs/tcm-bf518.h
index 042d789..52055e8 100644
--- a/include/configs/tcm-bf518.h
+++ b/include/configs/tcm-bf518.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf518-0.0
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_PARA
 
 
diff --git a/include/configs/tcm-bf537.h b/include/configs/tcm-bf537.h
index 9036ce3..8ded175 100644
--- a/include/configs/tcm-bf537.h
+++ b/include/configs/tcm-bf537.h
@@ -11,6 +11,7 @@
 /*
  * Processor Settings
  */
+#define CONFIG_BFIN_CPU             bf537-0.2
 #define CONFIG_BFIN_BOOT_MODE       BFIN_BOOT_BYPASS
 
 