diff --git a/arch/powerpc/cpu/mpc512x/serial.c b/arch/powerpc/cpu/mpc512x/serial.c
index 558e4e2..5ee9cef 100644
--- a/arch/powerpc/cpu/mpc512x/serial.c
+++ b/arch/powerpc/cpu/mpc512x/serial.c
@@ -319,9 +319,8 @@ int serial_getcts_dev(unsigned int idx)
 		serial_puts_dev(port, s); \
 	}
 
-#define INIT_PSC_SERIAL_STRUCTURE(port, name, bus) { \
+#define INIT_PSC_SERIAL_STRUCTURE(port, name) { \
 	name, \
-	bus, \
 	serial##port##_init, \
 	serial##port##_uninit, \
 	serial##port##_setbrg, \
@@ -334,25 +333,25 @@ int serial_getcts_dev(unsigned int idx)
 #if defined(CONFIG_SYS_PSC1)
 DECLARE_PSC_SERIAL_FUNCTIONS(1);
 struct serial_device serial1_device =
-INIT_PSC_SERIAL_STRUCTURE(1, "psc1", "UART1");
+INIT_PSC_SERIAL_STRUCTURE(1, "psc1");
 #endif
 
 #if defined(CONFIG_SYS_PSC3)
 DECLARE_PSC_SERIAL_FUNCTIONS(3);
 struct serial_device serial3_device =
-INIT_PSC_SERIAL_STRUCTURE(3, "psc3", "UART3");
+INIT_PSC_SERIAL_STRUCTURE(3, "psc3");
 #endif
 
 #if defined(CONFIG_SYS_PSC4)
 DECLARE_PSC_SERIAL_FUNCTIONS(4);
 struct serial_device serial4_device =
-INIT_PSC_SERIAL_STRUCTURE(4, "psc4", "UART4");
+INIT_PSC_SERIAL_STRUCTURE(4, "psc4");
 #endif
 
 #if defined(CONFIG_SYS_PSC6)
 DECLARE_PSC_SERIAL_FUNCTIONS(6);
 struct serial_device serial6_device =
-INIT_PSC_SERIAL_STRUCTURE(6, "psc6", "UART6");
+INIT_PSC_SERIAL_STRUCTURE(6, "psc6");
 #endif
 
 __weak struct serial_device *default_serial_console(void)
diff --git a/arch/powerpc/cpu/mpc5xxx/serial.c b/arch/powerpc/cpu/mpc5xxx/serial.c
index 0e1a8ec..aa09f67 100644
--- a/arch/powerpc/cpu/mpc5xxx/serial.c
+++ b/arch/powerpc/cpu/mpc5xxx/serial.c
@@ -339,7 +339,6 @@ int serial1_tstc(void)
 struct serial_device serial0_device =
 {
 	"serial0",
-	"UART0",
 	serial0_init,
 	NULL,
 	serial0_setbrg,
@@ -357,7 +356,6 @@ __weak struct serial_device *default_serial_console(void)
 struct serial_device serial1_device =
 {
 	"serial1",
-	"UART1",
 	serial1_init,
 	NULL,
 	serial1_setbrg,
diff --git a/arch/powerpc/cpu/mpc8xx/serial.c b/arch/powerpc/cpu/mpc8xx/serial.c
index 21803f5..9239b24 100644
--- a/arch/powerpc/cpu/mpc8xx/serial.c
+++ b/arch/powerpc/cpu/mpc8xx/serial.c
@@ -391,7 +391,6 @@ smc_tstc(void)
 struct serial_device serial_smc_device =
 {
 	"serial_smc",
-	"SMC",
 	smc_init,
 	NULL,
 	smc_setbrg,
@@ -662,7 +661,6 @@ scc_tstc(void)
 struct serial_device serial_scc_device =
 {
 	"serial_scc",
-	"SCC",
 	scc_init,
 	NULL,
 	scc_setbrg,
@@ -702,7 +700,7 @@ kgdb_serial_init(void)
 {
 	int i = -1;
 
-	if (strcmp(default_serial_console()->ctlr, "SMC") == 0)
+	if (strcmp(default_serial_console()->name, "serial_smc") == 0)
 	{
 #if defined(CONFIG_8xx_CONS_SMC1)
 		i = 1;
@@ -710,7 +708,7 @@ kgdb_serial_init(void)
 		i = 2;
 #endif
 	}
-	else if (strcmp(default_serial_console()->ctlr, "SMC") == 0)
+	else if (strcmp(default_serial_console()->name, "serial_scc") == 0)
 	{
 #if defined(CONFIG_8xx_CONS_SCC1)
 		i = 1;
@@ -725,7 +723,7 @@ kgdb_serial_init(void)
 
 	if (i >= 0)
 	{
-		serial_printf("[on %s%d] ", default_serial_console()->ctlr, i);
+		serial_printf("[on %s%d] ", default_serial_console()->name, i);
 	}
 }
 
diff --git a/board/logicpd/zoom2/zoom2_serial.h b/board/logicpd/zoom2/zoom2_serial.h
index a6d2427..4e30587 100644
--- a/board/logicpd/zoom2/zoom2_serial.h
+++ b/board/logicpd/zoom2/zoom2_serial.h
@@ -33,7 +33,6 @@ extern int zoom2_debug_board_connected (void);
 
 #define S(a) #a
 #define N(a) S(quad##a)
-#define U(a) S(UART##a)
 
 #define QUAD_INIT(n)				\
 int quad_init_##n(void)				\
@@ -63,7 +62,6 @@ int quad_tstc_##n(void)				\
 struct serial_device zoom2_serial_device##n =	\
 {						\
 	N(n),					\
-	U(n),					\
 	quad_init_##n,				\
 	NULL,					\
 	quad_setbrg_##n,			\
diff --git a/drivers/serial/serial.c b/drivers/serial/serial.c
index 4afdd41..0d56e78 100644
--- a/drivers/serial/serial.c
+++ b/drivers/serial/serial.c
@@ -118,9 +118,8 @@ static NS16550_t serial_ports[4] = {
 	serial_puts_dev(port, s);}
 
 /* Serial device descriptor */
-#define INIT_ESERIAL_STRUCTURE(port,name,bus) {\
+#define INIT_ESERIAL_STRUCTURE(port, name) {\
 	name,\
-	bus,\
 	eserial##port##_init,\
 	NULL,\
 	eserial##port##_setbrg,\
@@ -326,16 +325,16 @@ serial_setbrg(void)
 
 DECLARE_ESERIAL_FUNCTIONS(1);
 struct serial_device eserial1_device =
-	INIT_ESERIAL_STRUCTURE(1,"eserial0","EUART1");
+	INIT_ESERIAL_STRUCTURE(1, "eserial0");
 DECLARE_ESERIAL_FUNCTIONS(2);
 struct serial_device eserial2_device =
-	INIT_ESERIAL_STRUCTURE(2,"eserial1","EUART2");
+	INIT_ESERIAL_STRUCTURE(2, "eserial1");
 DECLARE_ESERIAL_FUNCTIONS(3);
 struct serial_device eserial3_device =
-	INIT_ESERIAL_STRUCTURE(3,"eserial2","EUART3");
+	INIT_ESERIAL_STRUCTURE(3, "eserial2");
 DECLARE_ESERIAL_FUNCTIONS(4);
 struct serial_device eserial4_device =
-	INIT_ESERIAL_STRUCTURE(4,"eserial3","EUART4");
+	INIT_ESERIAL_STRUCTURE(4, "eserial3");
 
 __weak struct serial_device *default_serial_console(void)
 {
diff --git a/drivers/serial/serial_pxa.c b/drivers/serial/serial_pxa.c
index e457980..68469a4 100644
--- a/drivers/serial/serial_pxa.c
+++ b/drivers/serial/serial_pxa.c
@@ -268,7 +268,6 @@ static int ffuart_tstc(void)
 struct serial_device serial_ffuart_device =
 {
 	"serial_ffuart",
-	"PXA",
 	ffuart_init,
 	NULL,
 	ffuart_setbrg,
@@ -313,7 +312,6 @@ static int btuart_tstc(void)
 struct serial_device serial_btuart_device =
 {
 	"serial_btuart",
-	"PXA",
 	btuart_init,
 	NULL,
 	btuart_setbrg,
@@ -358,7 +356,6 @@ static int stuart_tstc(void)
 struct serial_device serial_stuart_device =
 {
 	"serial_stuart",
-	"PXA",
 	stuart_init,
 	NULL,
 	stuart_setbrg,
diff --git a/drivers/serial/serial_s3c24x0.c b/drivers/serial/serial_s3c24x0.c
index ff35ce5..12bcdd3 100644
--- a/drivers/serial/serial_s3c24x0.c
+++ b/drivers/serial/serial_s3c24x0.c
@@ -69,9 +69,8 @@ DECLARE_GLOBAL_DATA_PTR;
 		serial_puts_dev(port, s); \
 	}
 
-#define INIT_S3C_SERIAL_STRUCTURE(port, name, bus) { \
+#define INIT_S3C_SERIAL_STRUCTURE(port, name) { \
 	name, \
-	bus, \
 	s3serial##port##_init, \
 	NULL,\
 	s3serial##port##_setbrg, \
@@ -304,13 +303,13 @@ void serial_puts(const char *s)
 #if defined(CONFIG_SERIAL_MULTI)
 DECLARE_S3C_SERIAL_FUNCTIONS(0);
 struct serial_device s3c24xx_serial0_device =
-INIT_S3C_SERIAL_STRUCTURE(0, "s3ser0", "S3UART1");
+INIT_S3C_SERIAL_STRUCTURE(0, "s3ser0");
 DECLARE_S3C_SERIAL_FUNCTIONS(1);
 struct serial_device s3c24xx_serial1_device =
-INIT_S3C_SERIAL_STRUCTURE(1, "s3ser1", "S3UART2");
+INIT_S3C_SERIAL_STRUCTURE(1, "s3ser1");
 DECLARE_S3C_SERIAL_FUNCTIONS(2);
 struct serial_device s3c24xx_serial2_device =
-INIT_S3C_SERIAL_STRUCTURE(2, "s3ser2", "S3UART3");
+INIT_S3C_SERIAL_STRUCTURE(2, "s3ser2");
 
 __weak struct serial_device *default_serial_console(void)
 {
diff --git a/drivers/serial/serial_s5p.c b/drivers/serial/serial_s5p.c
index 6604aa9..6819bb0 100644
--- a/drivers/serial/serial_s5p.c
+++ b/drivers/serial/serial_s5p.c
@@ -183,9 +183,8 @@ int s5p_serial##port##_tstc(void) { return serial_tstc_dev(port); } \
 void s5p_serial##port##_putc(const char c) { serial_putc_dev(c, port); } \
 void s5p_serial##port##_puts(const char *s) { serial_puts_dev(s, port); }
 
-#define INIT_S5P_SERIAL_STRUCTURE(port, name, bus) { \
+#define INIT_S5P_SERIAL_STRUCTURE(port, name) { \
 	name, \
-	bus, \
 	s5p_serial##port##_init, \
 	NULL, \
 	s5p_serial##port##_setbrg, \
@@ -196,16 +195,16 @@ void s5p_serial##port##_puts(const char *s) { serial_puts_dev(s, port); }
 
 DECLARE_S5P_SERIAL_FUNCTIONS(0);
 struct serial_device s5p_serial0_device =
-	INIT_S5P_SERIAL_STRUCTURE(0, "s5pser0", "S5PUART0");
+	INIT_S5P_SERIAL_STRUCTURE(0, "s5pser0");
 DECLARE_S5P_SERIAL_FUNCTIONS(1);
 struct serial_device s5p_serial1_device =
-	INIT_S5P_SERIAL_STRUCTURE(1, "s5pser1", "S5PUART1");
+	INIT_S5P_SERIAL_STRUCTURE(1, "s5pser1");
 DECLARE_S5P_SERIAL_FUNCTIONS(2);
 struct serial_device s5p_serial2_device =
-	INIT_S5P_SERIAL_STRUCTURE(2, "s5pser2", "S5PUART2");
+	INIT_S5P_SERIAL_STRUCTURE(2, "s5pser2");
 DECLARE_S5P_SERIAL_FUNCTIONS(3);
 struct serial_device s5p_serial3_device =
-	INIT_S5P_SERIAL_STRUCTURE(3, "s5pser3", "S5PUART3");
+	INIT_S5P_SERIAL_STRUCTURE(3, "s5pser3");
 
 __weak struct serial_device *default_serial_console(void)
 {
diff --git a/include/serial.h b/include/serial.h
index f21d961..e6d3859 100644
--- a/include/serial.h
+++ b/include/serial.h
@@ -2,11 +2,9 @@
 #define __SERIAL_H__
 
 #define NAMESIZE 16
-#define CTLRSIZE 8
 
 struct serial_device {
 	char name[NAMESIZE];
-	char ctlr[CTLRSIZE];
 
 	int  (*init) (void);
 	int  (*uninit) (void);